--RandomMount V1.0.00
--Original Author: Mike Hendricks(AttilaTheFun)
--Continuing Author: t4t3rt0t
--Description:
--              This add-on makes it simple to summon a random mount it takes into account ridding level, cold weather flying,
--              flying areas, even race and summons an appropriate mount.
--              It has a simple interface /mnt: /rmount: Will summon riding/flying mounts in the appropriate areas. mnt and rmount are interchangeable
--                                        /mnt riding: Summons riding mounts in flying areas
--                                        /mnt flying: Attempt to summon a flying mount
--                                        /mnt help: Display help
--                                        /mnt % (search Term): Summons a mount based on specified search term
--                                                example: to summon a skeletal warhorse type: /mnt skeletal
--                                        /mnt config: Prints the current configuration
--                                        /mnt rfilter: Toggle mount filtering
--                                        /mnt safefly: Toggle double click to dismount while flying
--                                        /mnt rfilters: List current filters
--                                        /mnt locfilter: Toggle filter to summon only specific mounts in specific locations
--                                        /mnt addloc % (zone:mount name1, mount name2, ...): Add locations and mounts to location checking. Separate mounts with commas. Use * as a wildcard to specify all mounts.
--                                        /mnt removeloc % (zone:mount name1, mount name2, ...): Removes locations and mounts from location checking. Separate mounts with commas.
--                                        /mnt loctable: Print the current location filtering table.
--                                        /mnt clearloc: Clears location filters
--                                        /mnt remove %: Remove all mounts matching % if rfilter is enabled
--                                        /mnt clear: Clears all filters
--                                        /mnt clearrem: Clears the mount removal table
--                                        /mnt whereami: Prints your zone and mini-map zone.
--                                        /mnt title: Enable or disable random title change.
--                                        /mnt icon: Enable or disable changing random mount macro icons to the last summoned mount.
--                                        /mnt oculus: Create a macro that will summon the drakes in The Oculus if you have them in your inventory.
--                                        /mnt PrintHelp("druid: Create a macro for druids that will cancel your form before trying to summon a mount.
--                                        /mnt debug: Toggle debug printing for posting error messages
--                                        /mnt No Flag: Summon a appropriate mount for the area

--If you are in undercity most mounts are to large to get easily throug out of the elivators, so if you have wolf,
-- or skeletal warhorses it will summon only those inside of undercity.

-- mount dictionary to compensate for wow's terrible GetCompanionInfo("MOUNT", i) command.
--One would assume info would imply useful things like can it fly and what skill is required etc.
--1  = riding mount
--2  = flying mount
--3  = riding / flying mount

-- missing mounts
--'Thalassian Warhorse': 1, 'Thalassian Charger': 1,

local mountDict = {
[60025]={2, "Albino Drake"},
[43688]={1, "Amani War Bear"},
[16056]={1, "Ancient Frostsaber"},
[48778]={1, "Acherus Deathcharger"},
[66906]={1, "Argent Charger"},
[63844]={2, "Argent Hippogryph"},
[67466]={1, "Argent Warhorse"},
[61230]={2, "Armored Blue Wind Rider"},
[60114]={1, "Armored Brown Bear"},
[60116]={1, "Armored Brown Bear"},
[61229]={2, "Armored Snowy Gryphon"},
[40192]={2, "Ashes of Al'ar"},
[59567]={2, "Azure Drake"},
[41514]={2, "Azure Netherwing Drake"},
[51412]={1, "Big Battle Bear"},
[58983]={1, "Big Blizzard Bear"},
[64987]={1, "Big Blizzard Bear [PH]"},
[71342]={3, "Big Love Rocket"},
[22719]={1, "Black Battlestrider"},
[62048]={2, "Black Dragonhawk Mount"},
[59650]={2, "Black Drake"},
[35022]={1, "Black Hawkstrider"},
[16055]={1, "Black Nightsaber"},
[59572]={1, "Black Polar Bear"},
[59976]={2, "Black Proto-Drake"},
[26656]={1, "Black Qiraji Battle Tank"},
[6896]={1, "Black Ram"},
[17461]={1, "Black Ram"},
[64977]={1, "Black Skeletal Horse"},
[470]={1, "Black Stallion"},
[60118]={1, "Black War Bear"},
[60119]={1, "Black War Bear"},
[48027]={1, "Black War Elekk"},
[22718]={1, "Black War Kodo"},
[59785]={1, "Black War Mammoth"},
[59788]={1, "Black War Mammoth"},
[22720]={1, "Black War Ram"},
[22721]={1, "Black War Raptor"},
[22717]={1, "Black War Steed"},
[22723]={1, "Black War Tiger"},
[22724]={1, "Black War Wolf"},
[578]={1, "Black Wolf"},
[64658]={1, "Black Wolf"},
[72808]={2, "Bloodbathed Frostbrood Vanquisher"},
[61996]={2, "Blue Dragonhawk"},
[59568]={2, "Blue Drake"},
[35020]={1, "Blue Hawkstrider"},
[10969]={1, "Blue Mechanostrider"},
[33630]={1, "Blue Mechanostrider"},
[59996]={2, "Blue Proto-Drake"},
[25953]={1, "Blue Qiraji Battle Tank"},
[6897]={1, "Blue Ram"},
[39803]={2, "Blue Riding Nether Ray"},
[17463]={1, "Blue Skeletal Horse"},
[64656]={1, "Blue Skeletal Warhorse"},
[32244]={2, "Blue Wind Rider"},
[50869]={1, "Brewfest Kodo"},
[43899]={1, "Brewfest Ram"},
[50870]={1, "Brewfest Ram"},
[49378]={1, "Brewfest Riding Kodo"},
[59569]={2, "Bronze Drake"},
[34406]={1, "Brown Elekk"},
[458]={1, "Brown Horse"},
[18990]={1, "Brown Kodo"},
[59573]={1, "Brown Polar Bear"},
[6899]={1, "Brown Ram"},
[17464]={1, "Brown Skeletal Horse"},
[6654]={1, "Brown Wolf"},
[58615]={2, "Brutal Nether Drake"},
[75614]={3, "Celestial Steed"},
[43927]={2, "Cenarion War Hippogryph"},
[23214]={1, "Charger"},
[6648]={1, "Chestnut Mare"},
[41515]={2, "Cobalt Netherwing Drake"},
[39315]={1, "Cobalt Riding Talbuk"},
[34896]={1, "Cobalt War Talbuk"},
[73313]={3, "Crimson Deathcharger"},
[39316]={1, "Dark Riding Talbuk"},
[34790]={1, "Dark War Talbuk"},
[63635]={1, "Darkspear Raptor"},
[63637]={1, "Darnassian Nightsaber"},
[64927]={2, "Deadly Gladiator's Frostwyrm"},
[6653]={1, "Dire Wolf"},
[23161]={1, "Dreadsteed"},
[32239]={2, "Ebon Gryphon"},
[8395]={1, "Emerald Raptor"},
[63639]={1, "Exodar Elekk"},
[5784]={1, "Felsteed"},
[36702]={1, "Fiery Warhorse"},
[17458]={1, "Fluorescent Green Mechanostrider"},
[61451]={2, "Flying Carpet"},
[44153]={2, "Flying Machine"},
[63643]={1, "Forsaken Warhorse"},
[17460]={1, "Frost Ram"},
[43810]={2, "Frost Wyrm"},
[23509]={1, "Frostwolf Howler"},
[51960]={2, "Frostwyrm Mount"},
[75596]={2, "Frosty Flying Carpet"},
[63638]={1, "Gnomeregan Mechanostrider"},
[32235]={2, "Golden Gryphon"},
[16060]={1, "Golden Sabercat"},
[59810]={1, "Grand Black War Mammoth"},
[59811]={1, "Grand Black War Mammoth"},
[61465]={1, "Grand Black War Mammoth"},
[61467]={1, "Grand Black War Mammoth"},
[60136]={1, "Grand Caravan Mammoth"},
[60140]={1, "Grand Caravan Mammoth"},
[59802]={1, "Grand Ice Mammoth"},
[59804]={1, "Grand Ice Mammoth"},
[61469]={1, "Grand Ice Mammoth"},
[61470]={1, "Grand Ice Mammoth"},
[35710]={1, "Gray Elekk"},
[18989]={1, "Gray Kodo"},
[6777]={1, "Gray Ram"},
[459]={1, "Gray Wolf"},
[63639]={1, "Great Azuremyst Elekk"},
[35713]={1, "Great Blue Elekk"},
[49379]={1, "Great Brewfest Kodo"},
[23249]={1, "Great Brown Kodo"},
[34407]={1, "Great Elite Elekk"},
[65641]={1, "Great Golden Kodo"},
[23248]={1, "Great Gray Kodo"},
[35712]={1, "Great Green Elekk"},
[63641]={1, "Great Mulgore Kodo"},
[35714]={1, "Great Purple Elekk"},
[65637]={1, "Great Red Elekk"},
[23247]={1, "Great White Kodo"},
[18991]={1, "Green Kodo"},
[15780]={1, "Green Mechanostrider"},
[17453]={1, "Green Mechanostrider"},
[61294]={2, "Green Proto-Drake"},
[26056]={1, "Green Qiraji Battle Tank"},
[39798]={2, "Green Riding Nether Ray"},
[17465]={1, "Green Skeletal Warhorse"},
[32245]={2, "Green Wind Rider"},
[48025]={3, "Headless Horseman's Mount"},
[59797]={1, "Ice Mammoth"},
[59799]={1, "Ice Mammoth"},
[72807]={2, "Icebound Frostbrood Vanquisher"},
[17459]={1, "Icy Blue Mechanostrider Mod A"},
[72286]={3, "Invincible"},
[63956]={2, "Ironbound Proto-Drake"},
[63636]={1, "Ironforge Ram"},
[10795]={1, "Ivory Raptor"},
[17450]={1, "Ivory Raptor"},
[65917]={1, "Magic Rooster"},
[66122]={1, "Magic Rooster"},
[66123]={1, "Magic Rooster"},
[66124]={1, "Magic Rooster"},
[61309]={2, "Magnificent Flying Carpet"},
[55531]={1, "Mechano-hog"},
[60424]={1, "Mekgineer's Chopper"},
[44317]={2, "Merciless Nether Drake"},
[44744]={2, "Merciless Nether Drake"},
[63796]={2, "Mimiron's Head"},
[16084]={1, "Mottled Red Raptor"},
[29059]={1, "Naxxramas Deathcharger"},
[3363]={2, "Nether Drake"},
[28828]={2, "Nether Drake"},
[10798]={1, "Obsidian Raptor"},
[41513]={2, "Onyx Netherwing Drake"},
[69395]={2, "Onyxian Drake"},
[66846]={1, "Ochre Skeletal Warhorse"},
[63640]={1, "Orgrimmar Wolf"},
[471]={1, "Palamino"},
[16082]={1, "Palomino"},
[32345]={2, "Peep the Phoenix Mount"},
[472]={1, "Pinto"},
[60021]={2, "Plagued Proto-Drake"},
[16058]={1, "Primal Leopard"},
[35711]={1, "Purple Elekk"},
[35018]={1, "Purple Hawkstrider"},
[17455]={1, "Purple Mechanostrider"},
[41516]={2, "Purple Netherwing Drake"},
[39801]={2, "Purple Riding Nether Ray"},
[23246]={1, "Purple Skeletal Warhorse"},
[66090]={1, "Quel'dorei Steed"},
[41252]={1, "Raven Lord"},
[17456]={1, "Red and Blue Mechanostrider"},
[61997]={2, "Red Dragonhawk"},
[59570]={2, "Red Drake"},
[34795]={1, "Red Hawkstrider"},
[10873]={1, "Red Mechanostrider"},
[59961]={2, "Red Proto-Drake"},
[26054]={1, "Red Qiraji Battle Tank"},
[39800]={2, "Red Riding Nether Ray"},
[17462]={1, "Red Skeletal Horse"},
[22722]={1, "Red Skeletal Warhorse"},
[579]={1, "Red Wolf"},
[16080]={1, "Red Wolf"},
[18363]={1, "Riding Kodo"},
[30174]={1, "Riding Turtle"},
[17481]={1, "Rivendare's Deathcharger"},
[63963]={2, "Rusted Proto-Drake"},
[64731]={1, "Sea Turtle"},
[66087]={2, "Silver Covenant Hippogryph"},
[39802]={2, "Silver Riding Nether Ray"},
[39317]={1, "Silver Riding Talbuk"},
[34898]={1, "Silver War Talbuk"},
[63642]={1, "Silvermoon Hawkstrider"},
[8980]={1, "Skeletal Horse"},
[32240]={2, "Snowy Gryphon"},
[42776]={1, "Spectral Tiger"},
[10789]={1, "Spotted Frostsaber"},
[15781]={1, "Steel Mechanostrider"},
[23510]={1, "Stormpike Battle Charger"},
[63232]={1, "Stormwind Steed"},
[66847]={1, "Striped Dawnsaber"},
[8394]={1, "Striped Frostsaber"},
[10793]={1, "Striped Nightsaber"},
[34767]={1, "Summon Charger"},
[34769]={1, "Summon Warhorse"},
[66091]={1, "Sunreaver Hawkstrider"},
[66088]={2, "Sunreaver Dragonhawk"},
[68057]={1, "Swift Alliance Steed"},
[32242]={2, "Swift Blue Gryphon"},
[23241]={1, "Swift Blue Raptor"},
[43900]={1, "Swift Brewfest Ram"},
[23238]={1, "Swift Brown Ram"},
[23229]={1, "Swift Brown Steed"},
[23250]={1, "Swift Brown Wolf"},
[65646]={1, "Swift Burgundy Wolf"},
[63635]={1, "Swift Darkspear Raptor"},
[63637]={1, "Swift Darnassian Mistsaber"},
[23220]={1, "Swift Dawnsaber"},
[63232]={1, "Swift Elwynn Steed"},
[23221]={1, "Swift Frostsaber"},
[23239]={1, "Swift Gray Ram"},
[65640]={1, "Swift Gray Steed"},
[23252]={1, "Swift Gray Wolf"},
[32290]={2, "Swift Green Gryphon"},
[35025]={1, "Swift Green Hawkstrider"},
[23225]={1, "Swift Green Mechanostrider"},
[32295]={2, "Swift Green Wind Rider"},
[68056]={1, "Swift Horde Wolf"},
[63636]={1, "Swift Ironforge Ram"},
[23219]={1, "Swift Mistsaber"},
[61442]={2, "Swift Mooncloth Carpet"},
[65636]={1, "Swift Moonsaber"},
[65638]={1, "Swift Moonsaber"},
[37015]={2, "Swift Nether Drake"},
[23242]={1, "Swift Olive Raptor"},
[23243]={1, "Swift Orange Raptor"},
[63640]={1, "Swift Orgrimmar Wolf"},
[23227]={1, "Swift Palomino"},
[33660]={1, "Swift Pink Hawkstrider"},
[32292]={2, "Swift Purple Gryphon"},
[35027]={1, "Swift Purple Hawkstrider"},
[65644]={1, "Swift Purple Raptor"},
[32297]={2, "Swift Purple Wind Rider"},
[24242]={1, "Swift Razzashi Raptor"},
[32289]={2, "Swift Red Gryphon"},
[65639]={1, "Swift Red Hawkstrider"},
[32246]={2, "Swift Red Wind Rider"},
[61444]={2, "Swift Shadoweave Carpet"},
[63642]={1, "Swift Silvermoon Hawkstrider"},
[42777]={1, "Swift Spectral Tiger"},
[61446]={2, "Swift Spellfire Carpet"},
[23338]={1, "Swift Stormsaber"},
[23251]={1, "Swift Timber Wolf"},
[65643]={1, "Swift Violet Ram"},
[47037]={1, "Swift War Elekk"},
[35028]={1, "Swift Warstrider"},
[46628]={1, "Swift White Hawkstrider"},
[23223]={1, "Swift White Mechanostrider"},
[23240]={1, "Swift White Ram"},
[23228]={1, "Swift White Steed"},
[23222]={1, "Swift Yellow Mechanostrider"},
[32296]={2, "Swift Yellow Wind Rider"},
[48954]={1, "Swift Zhevra"},
[49322]={1, "Swift Zhevra"},
[24252]={1, "Swift Zulian Tiger"},
[39318]={1, "Tan Riding Talbuk"},
[34899]={1, "Tan War Talbuk"},
[16059]={1, "Tawny Sabercat"},
[32243]={2, "Tawny Wind Rider"},
[18992]={1, "Teal Kodo"},
[63641]={1, "Thunder Bluff Kodo"},
[580]={1, "Timber Wolf"},
[60002]={2, "Time-Lost Proto-Drake"},
[61425]={1, "Traveler's Tundra Mammoth"},
[61447]={1, "Traveler's Tundra Mammoth"},
[44151]={2, "Turbo-Charged Flying Machine"},
[65642]={1, "Turbostrider"},
[10796]={1, "Turquoise Raptor"},
[59571]={2, "Twilight Drake"},
[17454]={1, "Unpainted Mechanostrider"},
[42781]={1, "Upper Deck - Spectral Tiger Mount"},
[49193]={2, "Vengeful Nether Drake"},
[64659]={1, "Venomhide Ravasaur"},
[46102]={1, "Venomhide Ravasaur"},
[41517]={2, "Veridian Netherwing Drake"},
[41518]={2, "Violet Netherwing Drake"},
[60024]={2, "Violet Proto-Drake"},
[10799]={1, "Violet Raptor"},
[13819]={1, "Warhorse"},
[64657]={1, "White Kodo"},
[15779]={1, "White Mechanostrider Mod B"},
[54753]={1, "White Polar Bear Mount"},
[6898]={1, "White Ram"},
[39319]={1, "White Riding Talbuk"},
[65645]={1, "White Skeletal Warhorse"},
[468]={1, "White Stallion"},
[16083]={1, "White Stallion"},
[34897]={1, "White War Talbuk"},
[54729]={2, "Winged Steed of the Ebon Blade"},
[581]={1, "Winter Wolf"},
[16081]={1, "Winter Wolf"},
[17229]={1, "Winterspring Frostsaber"},
[59791]={1, "Wooly Mammoth"},
[59793]={1, "Wooly Mammoth"},
[46197]={2, "X-51 Nether-Rocket"},
[46199]={2, "X-51 Nether-Rocket X-TREME"},
[75973]={2, "X-53 Touring Rocket"},
[26055]={1, "Yellow Qiraji Battle Tank"},
[73629]={1, "Summon Exarch's Elekk"},
[73630]={1, "Summon Great Exarch's Elekk"},
[69826]={1, "Summon Great Sunwalker Kodo"},
[69820]={1, "Summon Sunwalker Kodo"}}

--Saved Variables
debug = false                                                           --display debug info if enabled
debug2 = false                                                           --Display debug info on all mounts
notWanted = {}                                                          --Mounts that are not wanted to be summoned
epicfly = true                                                          --Enable or disable epic flying mounts
epicride = true                                                         --Enable or disable epic riding mounts
removeMount = false                                                     --Enable or disable notWanted mounts
locationChk = true                                                      --enable or disable specific mounts in special locations
locations = {}                                                          --locations to summon specific mounts(specialMounts)
specialMounts = {}                                                      --special mounts to summon if in a specific location
rndTitle = false                                                        --Randomly change the title when summoning a mount
safeFly = false                                                         --Safe flying dismount if flying
macroIcon = false                                                       --Update the macro icon with last summoned mount
zones = {}                                                              --Contains the list of location filters

--[[
zones = { ["sunreaver's sanctuary"] = {"warhorse", "talbuk"},
          ["dalaran"] = {"mammoth"},
          ["krasus' landing"] = {"*"},
          ["the violet citadel"] = {"*"},
          ["orgrimmar"] = {"wolf", "raptor"},
          ["undercity"] = {"skeletal"},
          ["silvermoon city"] = {"hawkstrider"},
          ["skettis"] = {"nether ray"} }
--]]

local nosummonlist = {}                                                 --Stores the last few mounts summoned so it won't summon it again
local lastTime = GetTime()                                             --Safe flying last time that dismount was called

--bindings
BINDING_HEADER_RANDOMMOUNT = "Random Mount"
BINDING_NAME_RANDOMMOUNT_REG = "Auto Summon"
BINDING_NAME_RANDOMMOUNT_RIDING = "Summon Riding"
BINDING_NAME_RANDOMMOUNT_FLYING = "Summon Flying"

function RandomMount_OnLoad()
	SlashCmdList["RandomMount"] = FindMount;
	SLASH_RandomMount1 = "/mnt";
	SLASH_RandomMount2 = "/rmount";
end

function dumyFindMount()
    FindMount()
end

function CanFlyHere( )
	-- Check for flyable area
	if not IsFlyableArea( ) then
		if GetRealZoneText( ) == "Wintergrasp" and GetWintergraspWaitTime() ~= nil then
			return( true )
		end
		return( false )
	end

	local zoneText = GetRealZoneText()
	local coldWeather = IsUsableSpell( "Cold Weather Flying" )
	local oldworld = IsUsableSpell( "Flight Master's License" )
	local outland =  GetRidingSkill()
	for j=1,5 do
		Index = { GetMapZones(j) }
		-- Zone Check
		for i, zone in ipairs( Index ) do
			if zoneText == zone then
				if oldworld and (j ~= 3 and j ~= 4) then
					return( true )
				elseif outland >= 225 and j == 3 then
					return( true )
				elseif coldWeather and j == 4 then
					return( true )
				end
				return( false )
			end
		end
	end
end

function GetRidingSkill()
	local name,texture,offset,numSpells = GetSpellTabInfo(1)
	for i=1,numSpells do
		local spellName = GetSpellBookItemName(i, BOOKTYPE_SPELL)
		if spellName == "Master Riding" then
			return( 300 )
		elseif spellName == "Artisan Riding" then
			return( 300 )
		elseif spellName == "Expert Riding" then
			return( 225 )
		elseif spellName == "Journeyman Riding" then
			return( 150 )
		elseif spellName == "Apprentice Riding" then
			return( 150 )
		end
	end
	return( 0 )
end 

function seaTurtle()
    for i=1,GetNumCompanions("MOUNT"),1 do
        local _, _, creatureSpellID = GetCompanionInfo("MOUNT", i)
        if creatureSpellID == 64731 then   --Turtle: 64731 dire wolf: 6653
            --PrintHelp("sea turtle found", "FF00ffff")
            return i
        end
    end
    return -1
end

function HasZoneMounts(flying, qiraji, searchMount, search)
    --check to see if special zone mounts are learned and process search
    for i=1,GetNumCompanions("MOUNT"),1 do
        local _, creatureName, creatureSpellID = GetCompanionInfo("MOUNT", i)
        if search ~= '' then
            if string.find(string.lower(creatureName), string.lower(search)) then
                table.insert(searchMount, i)
            end
        end
        local chk = true
        if creatureName:find("Qiraji") then
            chk = true
            for n, notW in ipairs( notWanted ) do
                if string.find(string.lower(creatureName), string.lower(notW)) then
                    chk = false
                    break
                end
            end
            if chk then
                table.insert(qiraji, i)
            end
        else
			if mountDict[creatureSpellID] then
				if mountDict[creatureSpellID][1] >= 2 then
	            	table.insert(flying, i)
	            end
            else
                PrintHelp(creatureName .. " " .. creatureSpellID .. " not in table, please report on curse.com.", "FF00ff00")
            end
        end
    end
    return flying, qiraji, searchMount
end

function LookForLocation(loc)
    local zone = GetRealZoneText()
    local miniMap = GetMinimapZoneText()
    for i, v in ipairs(locations) do
        if string.find(string.lower(zone), string.lower(v)) or string.find(string.lower(miniMap), string.lower(v)) then
            for j, k in ipairs(specialMounts) do
                for i=1,GetNumCompanions("MOUNT"),1 do
                    local _, creatureName = GetCompanionInfo("MOUNT", i)
                    if string.find(string.lower(creatureName), string.lower(k)) then
                        return( true )
                    end
                end
            end
        end
    end
    return false
end

function lfmChk(creatureName)
	if locationChk then
        for j, k in ipairs(specialMounts) do
            if string.find(string.lower(creatureName), string.lower(k)) then
                return( true )
            end
        end
	end
	return false
end

-- from http://lua-users.org/wiki/SplitJoin  by PeterPrade
function splitString(delimiter, text)
	local list = {}
	local pos = 1
	if strfind("", delimiter, 1) then -- this would result in endless loops
		error("delimiter matches empty string!")
	end
	while 1 do
	    local first, last = strfind(text, delimiter, pos)
	    if first then -- found?
			tinsert(list, strsub(text, pos, first-1))
			pos = last+1
	    else
	      tinsert(list, strsub(text, pos))
	      break
		end
	end
	return list
end

function AddLocF( info )
    if string.len(info) > 0 then
        local i = string.find(info, ":");
        local locVar = string.sub(info, 0, i - 1)
        local mntVar = splitString(",", string.sub(info, i + 1));
        if not zones[string.lower(locVar)] then
            zones[string.lower(locVar)] = {}
        end
        for i, v in ipairs(mntVar) do
            local found = false
            for n, item in ipairs( zones[string.lower(locVar)] ) do
                if v == item then
                    PrintHelp(v .. " already added.", "FF00ff00")
                    found = true
                    break
                end
            end
            if not found then
                table.insert(zones[string.lower(locVar)], v)
            end
        end
        PrintHelp("When in " .. string.lower(locVar) .. " mounts with " .. table.concat(zones[string.lower(locVar)], ",") .. " will be summoned.", "FF00ff00")
    end
end

function printLocF()
    PrintHelp("Location Mount database", "FFff00ff")
    for i, v in pairs(zones) do
        PrintHelp(i .. ":", "FF00ff00")
        for j, w in ipairs(zones[i]) do
            PrintHelp("       " .. w, "FF00ff99")
        end
    end
end

function removeLocF(info)
    if string.len(info) > 0 then
        local i = string.find(info, ":");
        --if : not found then remove zone table
        if not i then
            PrintHelp("Zone " .. info .. " is no longer filtered.", "FF00ff00")
            zones[info] = nil
        else
            local locVar = string.sub(info, 0, i - 1)
            local mntVar = splitString(",", string.sub(info, i + 1))
            for i, v in ipairs(mntVar) do
                local found = false
                for n, item in ipairs( zones[locVar] ) do
                    if v == item then
                        PrintHelp(v .. " removed from " .. locVar .. ".", "FF00ff99")
                        table.remove(zones[locVar], n)
                        found = true
                        break
                    end
                end
                if not found then
                    PrintHelp(v .. " not found in " .. locVar .. ".", "FF00ff99")
                end
            end
            if #zones[locVar] == 0 then
                PrintHelp(locVar .. " removed because it has no mounts.", "FF00ff00")
                zones[locVar] = nil
            end
        end
    end
    -- if : found then remove zone table elements, not entire table, if table is empty place * to signify empty

end

function FindMount(arg1)
	local s = 0
	local r
	local qiraji = {}
	local flying = {}
	local search = ""
	local searchMount = {}
	local zoneText = GetRealZoneText()
	local zoneMounts = 2
	local canFly
	local ridingSK = GetRidingSkill()
	local inLocation = false                                --Used to check for location

    if arg1 == "riding" then
        canFly = false
    elseif arg1 == "help" then
        PrintHelp("Random Mount V0.9.84 optional flags:", "FFFFFF00")
        PrintHelp("mnt: rmount: Will summon riding/flying mounts in the appropriate areas. mnt and rmount are interchangeable", "FFFFFF00")
        PrintHelp("riding: Summons riding mounts in flying areas", "FFFFFF00")
        PrintHelp("flying: Attempt to summon a flying mount", "FFFFFF00")
        PrintHelp("help: Display help", "FFFFFF00")
        PrintHelp("% (search Term): Summons a mount based on specified search term \rexample: to summon a skeletal warhorse type: /mnt skeletal", "FFFFFF00")
        PrintHelp("config: Prints the current configuration", "FFFFFF00")
        PrintHelp("rfilter: Toggle mount filtering", "FFFFFF00")
        PrintHelp("safefly: Toggle double click to dismount while flying", "FFFFFF00")
        PrintHelp("rfilters: List current filters", "FFFFFF00")
        PrintHelp("locfilter: Toggle filter to summon only specific mounts in specific locations", "FFFFFF00")
        PrintHelp("addloc % (zone:mount name1, mount name2, ...): Add locations and mounts to location checking. Separate mounts with commas. Use * as a wildcard to specify all mounts.", "FFFFFF00")
        PrintHelp("removeloc % (zone:mount name1, mount name2, ...): Removes locations and mounts from location checking. Separate mounts with commas.", "FFFFFF00")
        PrintHelp("loctable: Print the current location filtering table.", "FFFFFF00")
        PrintHelp("clearloc: Clears location filters", "FFFFFF00")
        PrintHelp("remove %: Remove all mounts matching % if rfilter is enabled", "FFFFFF00")
        PrintHelp("clear: Clears all filters", "FFFFFF00")
        PrintHelp("clearrem: Clears the mount removal table", "FFFFFF00")
        PrintHelp("whereami: Prints your zone and mini-map zone, and map coordinates.", "FFFFFF00")
        PrintHelp("title: Enable or disable random title change.", "FFFFFF00")
        PrintHelp("icon: Enable or disable changing random mount macro icons to the last summoned mount.", "FFFFFF00")
        PrintHelp("oculus: Create a macro that will summon the drakes in The Oculus if you have them in your inventory.", "FFFFFF00")
        PrintHelp("druid: Create a macro for druids that will cancel your form before trying to summon a mount.", "FFFFFF00")
        PrintHelp("debug: Toggle debug printing for posting error messages", "FFFFFF00")
        PrintHelp("No Flag: Summon a appropriate mount for the area", "FFFFFF00")
        return
    elseif arg1 == "config" then
        if debug then
            PrintHelp("Debug: Enabled", "FF00ff00")
        else
            PrintHelp("Debug: Disabled", "FFff0000")
        end
        if removeMount then
            PrintHelp("Mounts filtered: " .. table.concat(notWanted, ", "), "FF00ff00")
        else
            PrintHelp("Mount Removal Disabled.", "FFff0000")
        end
        --if locationChk then
        --    PrintHelp("Locations checked: " .. table.concat(locations, ", "), "FF00ff00")
        --    PrintHelp("Location Mounts: " .. table.concat(specialMounts, ", "), "FF00ff00")
        --else
        --    PrintHelp("Location checking mount filtering disabled.", "FFff0000")
        --end
        if safeFly then
            PrintHelp("Safe flying enabled. Double click to dismount while flying", "FF00ff00")
        else
            PrintHelp("Safe flying disabled.", "FFff0000")
        end
        if rndTitle then
            PrintHelp("Random title enabled.", "FF00ff00")
        else
            PrintHelp("Random title disabled.", "FFff0000")
        end
        if macroIcon then
            PrintHelp("Icon changing enabled.", "FF00ff00")
        else
            PrintHelp("Icon changing disabled.", "FFff0000")
        end
        return
    elseif arg1 == "whereami" then
        local posX, posY = GetPlayerMapPosition("player")
        PrintHelp("You are in " .. GetRealZoneText( ) .. ", " .. GetMinimapZoneText( ) .. ", " .. posX .. ", " .. posY, "FF00ff00")
        return
    elseif arg1 == "debug" then
        if debug == false then
            debug = true
            PrintHelp("Debug information enabled.", "FF00ff00")
        elseif debug == true then
            debug = false
            PrintHelp("Debug information disabled.", "FFff0000")
        end
        return
    elseif arg1 == "oculus" then
        PrintHelp("Macro is being created", "FF00ff00")
        local macroId = CreateMacro("RndOclus", 12, "/script if (GetItemCount(37859)+GetItemCount(37860)+GetItemCount(37815)==0) then FindMount(\"\"); end\n/use item:37859\n/use item:37860\n/use item:37815\n#/mnt", nil, 1);
        return
    elseif arg1 == "druid" then
        PrintHelp("Macro is being created", "FF00ff00")
        local macroId = CreateMacro("RndDruid", 12, "/cancelform\n/rmount", nil, 1);
        return
    elseif arg1 == "debug2" then
        if debug2 == false then
            debug2 = true
            debug = true
            PrintHelp("Debug2 information enabled. Your chat window will be spamed.", "FF00ff00")
        elseif debug2 == true then
            debug2 = false
            PrintHelp("Debug2 information disabled.", "FFff0000")
        end
        return
     elseif arg1 == "locfilter" then
        if locationChk == false then
            locationChk = true
            PrintHelp("Location mount filtering enabled.", "FF00ff00")
        elseif locationChk == true then
            locationChk = false
            PrintHelp("Location mount filtering disabled.", "FFff0000")
        end
        return
    elseif arg1 == "rfilter" then
        if removeMount == false then
            removeMount = true
            PrintHelp("Mount removal enabled.", "FF00ff00")
        elseif removeMount == true then
            removeMount = false
            PrintHelp("Mount removal disabled.", "FFff0000")
        end
        return
    elseif arg1 == "safefly" then
        if safeFly == false then
            safeFly = true
            PrintHelp("Safe flying enabled. Double click to dismount while flying", "FF00ff00")
        elseif safeFly == true then
            safeFly = false
            PrintHelp("Safe flying disabled.", "FFff0000")
        end
        return
    elseif arg1 == "rfilters" then
        if removeMount then
            PrintHelp("Mounts filtered: " .. table.concat(notWanted, ", "), "FF00ffff")
        else
            PrintHelp("Mount removal disabled.", "FFff0000")
        end
        return
    elseif arg1 == "title" then
        if rndTitle == false then
            rndTitle = true
            PrintHelp("Random title enabled.", "FF00ff00")
        elseif rndTitle == true then
            rndTitle = false
            PrintHelp("Random title disabled.", "FFff0000")
        end
        return
    elseif arg1 == "icon" then
        if macroIcon == false then
            macroIcon = true
            PrintHelp("Icon changing enabled.", "FF00ff00")
        elseif macroIcon == true then
            macroIcon = false
            PrintHelp("Icon changing disabled.", "FFff0000")
        end
        return
    elseif arg1 == "clear" then
        notWanted = {}
        zones = {}
        --specialMounts = {}
        PrintHelp("All tables cleared.", "FF00ffff")
        return
    elseif arg1 == "clearrem" then
        notWanted = {}
        PrintHelp("Remove mount table cleared.", "FF00ffff")
        return
    elseif arg1 == "clearloc" then
        zones = {}
        PrintHelp("Special location table cleared.", "FF00ffff")
        return
    elseif arg1 == "loctable" then
        printLocF()
        return
    elseif arg1:find("removeloc") then
        PrintHelp(string.sub(arg1, 11), "FF00ff99")
        if string.len(string.sub(arg1, 11)) > 0 then
            removeLocF(string.sub(arg1, 11))
        end
        return
    elseif arg1 == "flying" then
        canFly = true
    elseif arg1:find("addloc") then
        if string.len(string.sub(arg1, 8)) > 0 then
            AddLocF(string.sub(arg1, 8))
        end
        return
    elseif arg1:find("remove") then
        local found = false
        if string.len(string.sub(arg1, 8)) > 0 then
            for n, notW in ipairs( notWanted ) do
                if string.sub(arg1, 8) == notW then
                    PrintHelp(string.sub(arg1, 8) .. " already added.", "FF00ffff")
                    found = true
                    break
                end
            end
            --PrintHelp(table.concat(notWanted, ", "), "FF00ffff")
            if not found then
                PrintHelp("Mounts matching " .. string.sub(arg1, 8) .. " will no longer be summoned.", "FF00ff00")
                table.insert(notWanted, string.sub(arg1, 8))
            end
        end
        return
    elseif arg1 == "rnd" then
      	r = randomSudo(GetNumCompanions("MOUNT"))
	    PrintHelp(r, "FF00ffff")
    else
        search = arg1
        canFly = CanFlyHere()
    end
    if IsMounted() then
        if safeFly and IsFlying() then
            local curTime = GetTime()
            if curTime < (lastTime + 0.5) then
                Dismount()
                return
            else
                lastTime = curTime
                return
            end
        else
            Dismount()
            return
        end
    end
    if UnitInVehicle(UnitName("player")) then
        VehicleExit()
        return
    end
    if rndTitle then
        local titles = {};
        for i=1,GetNumTitles(),1 do
            if IsTitleKnown(i) == 1 then
                table.insert(titles, i);
            end
        end
        SetCurrentTitle(titles[random(# titles)])
    end
    local flying, qiraji, searchMount = HasZoneMounts(flying, qiraji, searchMount, search)
    if search ~= "" and next (searchMount) == nil then
        PrintHelp("No matching mount found.", "FF00ffff") return
    end
    local repeatChk = true
    local runawayChk = 0
    numCompanions = GetNumCompanions("MOUNT")
    --if there are less than 10 mounts no real reason to check for repeats
    if numCompanions < 10 then
        repeatChk = false
    end
    local zoneChk = true
    if ridingSK >= 75 then
        r = seaTurtle()
        if IsSwimming() then
            runawayChk = 500
            --PrintHelp("Is swiming", "FF00ffff")
        end
        --PrintHelp("pre if" .. r, "FF00ffff")
        if r ~= -1 and search == "" and runawayChk == 500 then
            --PrintHelp("sea turtle", "FF00ffff")
        else
        	repeat
        		r = random(numCompanions)
        		s = TestMount(r, ridingSK, zoneText, canFly, flying, qiraji, searchMount, debug, inLocation, repeatChk, zoneChk)
        		runawayChk = runawayChk + 1                             --No mounts found after 1000 trys so just quit otherwise it will lock up
        		if runawayChk > 1000 then
                    s = true
                elseif runawayChk > 750 then
                    zoneChk = false
        		elseif runawayChk > 500 then                            --no acceptable mounts found in the first 500 trys so turn off can fly
                    canFly = false
                elseif repeatChk and runawayChk > 250 then              --Turn off repeatChk if no usable mounts are found within the first 250 checks
                    repeatChk = false
        		end
        	until s == true
        end
    	if runawayChk > 1000 then
    	   PrintHelp("No usable mounts found", "FFff0000")
    	elseif r == -1 then
            --PrintHelp("sea turtle 1", "FF00ffff")
    	   return
    	else
            if debug2 then
        	   PrintHelp("Runaway Check: " .. runawayChk .. " Number of mounts:" .. numCompanions, "FFffff99")
     	    end
     	    if InCombatLockdown() then
                if debug then
                    PrintHelp("You are in combat.", "FF00ff00")
                end
                return
            end
            CallCompanion("MOUNT", r)
            --Repeat Mount check
            table.insert(nosummonlist, r)
            if #nosummonlist > 5 then
                table.remove(nosummonlist, 1)
            end
            -- Change Macro Icons
            if macroIcon then
                local _, _, _, icon = GetCompanionInfo("MOUNT", r)
                local numglobal, numperchar = GetNumMacros();
                -- loop to change the icons of macros that are calling /rmount
                for i=1, numglobal, 1 do
                    -- Get iconIndex info
                    local numIcons = GetNumMacroIcons();
                    for i=1,numIcons do
                        if string.lower(GetMacroIconInfo(i)) == string.lower(icon) then
                            iconIndex = i
                            break
                        end
                    end
                    local name, texture, macrobody, localVar = GetMacroInfo(i);
                    if string.find(string.lower(macrobody), string.lower("/rmount")) or string.find(string.lower(macrobody), string.lower("/mnt")) then
                        --PrintHelp( texture .. " " .. icon, "FF00ff00")
                        EditMacro(i, nil, iconIndex)
                    end
                end
            end
        end
    end
end

function TestMount(r, ridingSK, zoneText, canFly, flying, qiraji, searchMount, debug, inLocation, repeatChk, zoneChk)
    local _, creatureName, creatureSpellID = GetCompanionInfo("MOUNT", r)
    local mv
    if mountDict[creatureSpellID] then
        mv = mountDict[creatureSpellID][1]
        if mv then
            --Remove Mount processing
            if removeMount then
                for n, notW in ipairs( notWanted ) do
                    if string.find(string.lower(creatureName), string.lower(notW)) or creatureSpellID == tonumber(notW) then
                        return false
                    end
                end
            end
            --Zone Checking
            if locationChk and zoneChk then
                realZone = GetRealZoneText()
                miniMapZone = GetMinimapZoneText()
                local found = false
                if zones[string.lower(miniMapZone)] then
                    zoneChk = false
                    for i, type in ipairs(zones[string.lower(miniMapZone)]) do
                        if strfind(string.lower(creatureName), string.lower(type)) or type == "*" then
                            zoneChk = true
                            found = true
                            if debug then
                                PrintHelp(type .. " : " .. creatureName .. " is found", "FFffff00")
                            end
                            break
                        end
                    end
                end
                if zones[string.lower(realZone)] then
                    if not found then
                        zoneChk = false
                        for i, type in ipairs(zones[string.lower(realZone)]) do
                            if strfind(string.lower(creatureName), string.lower(type)) or type == "*" then
                                zoneChk = true
                                if debug then
                                    PrintHelp(type .. " : " .. creatureName .. " is found", "FFffff00")
                                end
                                break
                            end
                        end
                    end
                end
                if not zoneChk then
                    return false
                end
            end
            --Repeat Mount check
            if repeatChk then
                for i, m in ipairs(nosummonlist) do
                    if m == r then
                        return false
                    end
                end
            end
            --flying mounts
            if canFly and #flying > 0 and ridingSK >= 225 then
                if ridingSK >= 225 and mv >= 2 then
                    if #searchMount > 0 then
                        for i, s in ipairs(searchMount) do
                            if r == s then
                                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, creatureSpellID, 12) end
                                return true
                            end
                        end
                    elseif inLocation then
                        if lfmChk(creatureName) then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, creatureSpellID, 11) end
                            return( true )
                        end
                    else
                        if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, creatureSpellID, 10) end
                        return true
                    end
                end
            --zone specific mounts
            elseif zoneText == "Ahn'Qiraj" and #qiraji > 0 then
                if ridingSK >= 150 and mv == 1 then
                    if #searchMount > 0 then
                        for i, s in ipairs(searchMount) do
                            if r == s then
                                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, creatureSpellID, 37) end
                                return( true )
                            end
                        end
                    elseif inLocation then
                        if lfmChk(creatureName) then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, creatureSpellID, 36) end
                            return( true )
                        end
                    elseif creatureName:find("Qiraji") then
                        if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, creatureSpellID, 35) end
                        return( true )
                    end
                end
            --Regular Mounts
            else
                if ridingSK >= 150 and mv ~= 2 and not creatureName:find("Qiraji") then
                    if #searchMount > 0 then
                        for i, s in ipairs(searchMount) do
                            if r == s then
                                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, creatureSpellID, 52) end
                                return( true )
                            end
                        end
                    elseif inLocation then
                        if lfmChk(creatureName) then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, creatureSpellID, 51) end
                            return( true )
                    	end
                   	else
                        if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, creatureSpellID, 50) end
                        return( true )
                    end
                end
            end
            if debug2 then
                PrintSummon("FFffff99", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, creatureSpellID, 00)
            end
        end
    end
end



function PrintHelp(cmd, color)
	print(format('|c%s%s|r', color, cmd))
end

function PrintSummon(color, creatureName, r, ridingSK, creatureDict, zoneText, canFly, creatureSpellID, mountNum)
    canFly = tostring(canFly)
	print(format("|c%s%s - Mnt#:%s - Skill: %s - type:%s - %s - %s - flyZone:%s - cID:%s - cond:%s|r", color, creatureName, r, ridingSK, creatureDict, zoneText, GetMinimapZoneText(), canFly, creatureSpellID, mountNum))
end

function randomSudo(max)
   local oldrandom = math.random
   local randomtable
   math.random = function ()
      if randomtable == nil then
         randomtable = {}
         for i = 1, max do
            randomtable[i] = oldrandom()
         end
      end
      local x = oldrandom()
      local i = 1 + math.floor(max*x)
      x, randomtable[i] = randomtable[i], x
      return x
   end
end
